import pytest


@pytest.mark.helpers
def test_001_save_answermsg2e(saveB64Artifact, admlc):

  requestBody = { "name":"afHost.afRealm.com" }
  responseBodyRef = { "success":"true", "response":"Forced node is now 'afHost.afRealm.com'" }

  # Send POST
  response = admlc.postDict("/node", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

  # Send POST
  response = admlc.postDict("/answermsg2e", { "action":"" })

  # Verify response
  assert response["status"] == 200
  assert response["body"]["success"] == "true"

  # Save artifact from base64 encoded string received
  saveB64Artifact(response["body"]["response"], "helpers/answermsg2e", False) # it is direct text content

@pytest.mark.helpers
def test_002_save_answermsg2c(saveB64Artifact, admlc):

  requestBody = { "name":"ownHostId.operatorRealm.com" }
  responseBodyRef = { "success":"true", "response":"Forced node is now 'ownHostId.operatorRealm.com'" }

  # Send POST
  response = admlc.postDict("/node", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

  # Send POST
  response = admlc.postDict("/answermsg2c", { "action":"" })

  # Verify response
  assert response["status"] == 200
  assert response["body"]["success"] == "true"

  # Save artifact from base64 encoded string received
  saveB64Artifact(response["body"]["response"], "helpers/answermsg2c", False) # it is direct text content
