import pytest


def test_001_change_working_directory_for_adml(admlc):

  requestBody = { "directory":"/tmp" }
  responseBodyRef = { "success":"true", "response":"New execution directory configured: /tmp" }

  # Send POST
  response = admlc.postDict("/change-dir", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

def test_002_change_to_invalid_working_directory_for_adml(admlc):

  requestBody = { "directory":"/this/is/invalid" }
  responseBodyRef = { "success":"false", "response":"Cannot assign provided execution directory: /this/is/invalid" }

  # Send POST
  response = admlc.postDict("/change-dir", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

def test_003_restore_working_directory_for_adml(admlc):

  requestBody = { "directory":"" }
  responseBodyRef = { "success":"true", "response":"New execution directory configured: /opt/adml" }

  # Send POST
  response = admlc.postDict("/change-dir", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

