// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_ReceiverFactoryImpl_hpp
#define anna_comm_ReceiverFactoryImpl_hpp

#include <anna/core/util/Recycler.hpp>

#include <anna/comm/ReceiverFactory.hpp>

namespace anna {

namespace comm {

class Factory;

/**
   Implementacion por defecto de una factoria de receptores.

   \param T Clase del receptor instanciado por esta factoria. Debe implementar el constructor
   vacio y un metodo que devuelve el nombre de la clase con la firma:

   \code
      static const char* className () throw ();
   \encode
*/
template <typename T> class ReceiverFactoryImpl : public ReceiverFactory {
public:
  /**
     Constructor.
  */
  ReceiverFactoryImpl() : ReceiverFactory(T::className()) {;}

private:
  Recycler<T> a_receivers;

  Receiver* do_create() throw() { return a_receivers.create(); }
  void do_release(Receiver* receiver) throw() { a_receivers.release(static_cast <T*>(receiver)); }
};

}
}

#endif

