// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_BinderSocket_hpp
#define anna_comm_handler_BinderSocket_hpp

#include <anna/comm/Handler.hpp>

namespace anna {

namespace comm {

class BinderSocket;

namespace handler {

class BinderSocket : public Handler {
public:
  BinderSocket(Communicator* communicator) :
    Handler(communicator, Handler::Type::BinderSocket, Support::None),
    a_binderSocket(NULL)
  {;}

  void setup(comm::BinderSocket* binderSocket) throw() { a_binderSocket = binderSocket; }

private:
  comm::BinderSocket* a_binderSocket;

  void initialize() throw(RuntimeException);
  void apply() throw(RuntimeException);
  void breakAddress(const in_addr_t&) throw() {;}
  void recoverAddress(const in_addr_t&) throw() {;}
  void finalize() throw();
  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

