// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_comm_ServerSessionReceiver_hpp
#define anna_diameter_comm_ServerSessionReceiver_hpp

#include <anna/comm/Receiver.hpp>
#include <anna/core/RuntimeException.hpp>


namespace anna {
namespace comm {
class Message;
class ClientSocket;
//class Server;
}
}


namespace anna {

namespace diameter {

namespace comm {


class ServerSession;


class ServerSessionReceiver : public anna::comm::Receiver {
public:
  virtual ~ServerSessionReceiver() {;}

  static const char* className() throw() { return "diameter.comm.ServerSessionReceiver"; }
  void setReference(ServerSession *s) throw() { a_session = s; }

  // base class virtuals
  void eventBreakLocalConnection(const anna::comm::ClientSocket&cli) throw();
  //void eventCreateConnection(const anna::comm::Server*srv) throw();

private:
  ServerSessionReceiver() : anna::comm::Receiver("diameter.comm.ServerSessionReceiver") { a_session = NULL; }
  void initialize() throw(anna::RuntimeException) {;}
  void apply(anna::comm::ClientSocket&, const anna::comm::Message&) throw(anna::RuntimeException);


  anna::diameter::comm::ServerSession *a_session;

  friend class anna::Allocator <ServerSessionReceiver>;
};


}
}
}

#endif

