// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_tid_Format_hpp
#define anna_diameter_helpers_tid_Format_hpp


#include <anna/core/RuntimeException.hpp>
#include <anna/core/define.autoenum.hpp>

// STL
#include <string>


namespace anna {

namespace diameter {

namespace helpers {

namespace tid {

/**
* Diameter TID Avp Data Format definition
*/
struct Format {

  enum _v {
    None = -1, // Initialized

    Date       // S8*  n
  };

  anna_declare_enum(diameter::helpers::tid::Format);

  /**
  * Format description
  * @param v Format type
  * @return Format description
  */
  static const char* asText(const Format::_v v) throw(anna::RuntimeException) {
    return asCString(v);
  }
};


}
}
}
}


#endif

