// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_ldap_internal_Timer_hpp
#define anna_ldap_internal_Timer_hpp

#include <anna/core/Allocator.hpp>

#include <anna/timex/Transaction.hpp>

namespace anna {

namespace ldap {

class Response;
class TimerManager;

class Timer : public timex::Transaction {
public:
  Response* getResponse() throw() { return reinterpret_cast <Response*>(getContext()); }
  const Response* getResponse() const throw() { return reinterpret_cast <const Response*>(getContext()); }

  std::string asString() const throw();

private:
  Timer() {;}

  void setResponse(Response* response) throw() { setContext(response); }
  void expire(timex::Engine*) throw(RuntimeException);

  friend class ldap::TimerManager;
  friend class Allocator<Timer>;
};

}
}

#endif

