// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/comm/DirectTransport.hpp>
#include <anna/comm/Message.hpp>

using namespace anna;

comm::TransportFactoryImpl <comm::DirectTransport> comm::DirectTransport::st_transportFactory;

comm::DirectTransport::DirectTransport() :
  comm::Transport() {
  setInputMessage(new Message());
}

comm::DirectTransport::~DirectTransport() {
  delete getInputMessage();
}

//-------------------------------------------------------------------------------------------
// Recordar que 'message' esta alojado en la memoria intermedia que el comm::ClientSocket
// tiene reservada para ir guardando los mensajes en proceso => no es una copia si no una
// referencia un puntero.
//
// (1) Transfiere la referencia de message al cuerpo del mensaje. Ojo!! tampoco hace copia.
//-------------------------------------------------------------------------------------------
const comm::Message* comm::DirectTransport::decode(const DataBlock& data)
throw(RuntimeException) {
  return getInputMessage()->setBody(data);
}

const DataBlock& comm::DirectTransport::code(comm::Message& message)
throw(RuntimeException) {
  return a_forCode = message.code();
}


